=== debian/changelog ===
yabause (0.9.15-3) unstable; urgency=medium

  * Team Upload
  * Bump debhelper from old 12 to 13.
  * add d/.gitignore
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * Update standards version to 4.6.2, no further changes needed.

  [ Bo YU & Eric Long <i@hack3r.moe> ]
  * Add support for riscv64, (Closes: #1019213)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 06 Dec 2023 11:05:48 +0100

yabause (0.9.15-2) unstable; urgency=medium

  * Team upload.
  * Drop yabause-gtk. (Closes: #967843)

 -- Bastian Germann <bage@debian.org>  Sat, 26 Aug 2023 12:48:13 +0000

yabause (0.9.15-1) experimental; urgency=medium

  * Team upload.
  * New upstream release. (Closes: #832486)
    - fixes command line handling (Closes: #797700)
  * Build-depend on libglew-dev to link with system glew.
  * Update d/copyright for new upstream version.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 25 Aug 2019 19:21:06 +0200

yabause (0.9.14-4) unstable; urgency=medium

  * Team upload.
  * Port to Qt5. (Closes: #875242)
  * Remove trailing whitespace in d/changelog.
  * Update watch file.
  * Update debhelper compat level to 12.
  * Update Standards-Version to 4.4.0:
    - declare that d/rules does not require root
  * Mark -common as Multi-Arch: foreign.
  * Use https for homepage.
  * Enable all hardening options.
  * Build against sdl2 instead of sdl1.2.
  * Use installed path for pixmaps so that dh_missing notices it.
  * Set 'set -e' in the script body of postinst/prerm.
  * Drop unused paragraphs from d/copyright.

 -- Reiner Herrmann <reiner@reiner-h.de>  Sun, 25 Aug 2019 14:49:38 +0200

yabause (0.9.14-3) unstable; urgency=medium

  * Team upload.
  * Update gtkglext-patch again and look for the correct include path.
    (Closes: #897548)
  * Switch to compat level 11.
  * Declare compliance with Debian Policy 4.1.4.
  * Drop deprecated menu files.
  * Remove README.source.
  * wrap-and-sort -sa.
  * Move the package to Git and salsa.debian.org.

 -- Markus Koschany <apo@debian.org>  Sat, 09 Jun 2018 18:15:32 +0200
