=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# CMake doesn't use CPPFLAGS, pass them to CFLAGS/CXXFLAGS to enable the
# missing (hardening) flags.
export DEB_CFLAGS_MAINT_APPEND   = $(shell dpkg-buildflags --get CPPFLAGS)
export DEB_CXXFLAGS_MAINT_APPEND = $(shell dpkg-buildflags --get CPPFLAGS)

export DEB_LDFLAGS_MAINT_APPEND = -Wl,-z,defs

export QT_SELECT=qt5

%:
	dh $@

ifeq ($(DEB_BUILD_ARCH), riscv64)
override_dh_auto_configure:
	dh_auto_configure -- -DYAB_PORTS=qt -DYAB_MULTIBUILD=1 -DYAB_OPTIMIZATION="" -DSH2_DYNAREC=OFF -DCMAKE_C_COMPILER=clang
override_dh_dwz:
else
override_dh_auto_configure:
	dh_auto_configure -- -DYAB_PORTS=qt -DYAB_MULTIBUILD=1 -DYAB_OPTIMIZATION="" -DSH2_DYNAREC=OFF
endif
